//
//  GLSmartDateCell.h
//  GLUtilityKit
//
//  Created by Jeffrey Early on 2/24/09.
//  Copyright 2009 Early Innovations, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


// Based on the DateCell from Corbin Dunn in the PhotoSearch example app.

typedef enum {
    DateCellDetailFullDateAndTime = 0,          // ie: Friday, April 13, 1978, 5:05 PM
    DateCellDetailLongDateAndTime,              // ie: April 13, 1978, 5:05 PM
    DateCellDetailMediumDateAndTime,            // ie: Apr 13, 1978, 5:05 PM
    DateCellDetailShortDateAndTime,             // ie: 4/13/1978, 5:05 PM
    DateCellDetailShortDate,                    // ie: 4/13/78
    DateCellDetailNumberOfDateFormats,          // Simply a count indicator
} DateCellDetailLevel;

typedef enum {
    DateCellDetailYesterday = 0,
    DateCellDetailYesterdayAndTime,
    DateCellDetailToday,
    DateCellDetailTodayAndTime,
    DateCellDetailNumberOfTodayAndYesterdays, 
} DateCellDetailTodayAndYesterdays;

@interface GLSmartDateCell : NSTextFieldCell {
    CGFloat iLastWidth;
    DateCellDetailLevel iDateDetailLevel;
    DateCellDetailTodayAndYesterdays iTodayAndYesterdayLevel;
	BOOL gCalculatedDetailLevelWidths ;
	CGFloat gDetailLevelWidths[DateCellDetailNumberOfDateFormats];
	CGFloat gDetailNaturalWidths[DateCellDetailNumberOfTodayAndYesterdays];
	BOOL shouldHideTime;
	BOOL shouldShowTimeZone;
}

@property BOOL shouldHideTime;
@property BOOL shouldShowTimeZone;

@end
